#ifndef MODULES_DPC_UTILS_INCLUDE_SKELETON_SKELETONWRAPPERHELPER_H_
#define MODULES_DPC_UTILS_INCLUDE_SKELETON_SKELETONWRAPPERHELPER_H_

#include "PubWrapper.h"

#define GENERATE_PUB_WRAPPER(NAME, DATA_WRAPPER, SKELETON_NAME, DATA_TYPE, EVENT_NAME)	\
using NAME ## Skeleton = SKELETON_NAME; \
using NAME ## Event = ara::com::internal::skeleton::event::EventAdapter<::DATA_TYPE>;	\
class NAME : public PubWrapper<NAME ## Skeleton, NAME ## Event, DATA_TYPE>	\
{	\
public:	\
	DATA_WRAPPER<DATA_TYPE> s;	\
	NAME(const std::string& name, ara::log::Logger& log) :	PubWrapper(s, name, log)	\
{}	\
private:	\
	NAME ## Event& GetEvent() override	\
	{	return _skeleton->EVENT_NAME;	} \
};


#endif /* MODULES_DPC_UTILS_INCLUDE_SKELETON_SKELETONWRAPPERHELPER_H_ */
